/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of Channel.xs. Do not edit this file, edit Channel.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Thread/Channel.xs"
#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#define NO_XSLOCKS
#include "XSUB.h"

#include "message.h"
#include "queue.h"

static int queue_destructor(pTHX_ SV* queue_object, MAGIC* mg) {
	message_queue* queue = (message_queue*)mg->mg_ptr;
	int alive;
	MUTEX_LOCK(&queue->mutex);
	alive = --queue->refcount;
	MUTEX_UNLOCK(&queue->mutex);
	if (!alive) {
		queue_destroy(queue);
		PerlMemShared_free(queue);
	}
	return 0;
}

static int queue_duplicator(pTHX_ MAGIC* mg, CLONE_PARAMS* params) {
	message_queue* queue = (message_queue*)mg->mg_ptr;
	MUTEX_LOCK(&queue->mutex);
	queue->refcount++;
	MUTEX_UNLOCK(&queue->mutex);
	return 0;
}

static const MGVTBL queue_magic = { NULL, NULL, NULL, NULL, queue_destructor, NULL, queue_duplicator, NULL };

#ifndef mg_findext
#define mg_findext(sv, magic, ptr) mg_find(sv, magic)
#endif

static message_queue* S_get_queue(pTHX_ SV* queue_object) {
	if (!sv_isobject(queue_object) || !sv_derived_from(queue_object, "Thread::Channel"))
		Perl_croak(aTHX_ "Something is very wrong, this is not a queue object\n");
	MAGIC* mg = mg_findext(SvRV(queue_object), PERL_MAGIC_ext, &queue_magic);
	return (message_queue*) mg->mg_ptr;
}
#define get_queue(object) S_get_queue(aTHX_ object)

#line 55 "lib/Thread/Channel.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 199 "lib/Thread/Channel.c"

XS_EUPXS(XS_Thread__Channel_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Thread__Channel_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    {
	SV*	class = ST(0)
;
#line 53 "lib/Thread/Channel.xs"
		message_queue* queue;
		SV* referent;
		MAGIC* mg;
#line 214 "lib/Thread/Channel.c"
	SV *	RETVAL;
#line 57 "lib/Thread/Channel.xs"
		queue = PerlMemShared_calloc(1, sizeof(message_queue));
		queue_init(queue);
		referent = newSV(0);
		mg = sv_magicext(referent, NULL, PERL_MAGIC_ext, &queue_magic, (const char*)queue, 0);
		mg->mg_flags |= MGf_DUP|MGf_COPY;
		RETVAL = newRV_noinc(referent);
		sv_bless(RETVAL, gv_stashsv(class, FALSE));
#line 224 "lib/Thread/Channel.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Thread__Channel_enqueue); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Thread__Channel_enqueue)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "object, ...");
    {
	SV*	object = ST(0)
;
#line 71 "lib/Thread/Channel.xs"
		message_queue* queue;
		const message* message;
#line 244 "lib/Thread/Channel.c"
#line 74 "lib/Thread/Channel.xs"
		queue = get_queue(object);
		if (items == 1)
			Perl_croak(aTHX_ "Can't send an empty list\n");
		PUSHMARK(MARK + 2);
		message_from_stack(message, MARK + 1);
		queue_enqueue(queue, message);
#line 252 "lib/Thread/Channel.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Thread__Channel_dequeue); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Thread__Channel_dequeue)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "object");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	object = ST(0)
;
#line 85 "lib/Thread/Channel.xs"
		message_queue* queue;
		const message* message;
#line 272 "lib/Thread/Channel.c"
#line 88 "lib/Thread/Channel.xs"
		queue = get_queue(object);
		message = queue_dequeue(queue);
		message_to_stack(message, GIMME_V);
		destroy_message(message);
#line 278 "lib/Thread/Channel.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Thread__Channel_dequeue_nb); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Thread__Channel_dequeue_nb)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "object");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	object = ST(0)
;
#line 98 "lib/Thread/Channel.xs"
		message_queue* queue;
		const message* message;
#line 299 "lib/Thread/Channel.c"
#line 101 "lib/Thread/Channel.xs"
		queue = get_queue(object);
		if (message = queue_dequeue_nb(queue)) {
			message_to_stack(message, GIMME_V);
			destroy_message(message);
		}
		else
			XSRETURN_EMPTY;
#line 308 "lib/Thread/Channel.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Thread__Channel); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Thread__Channel)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Thread::Channel::new", XS_Thread__Channel_new);
        newXS_deffile("Thread::Channel::enqueue", XS_Thread__Channel_enqueue);
        newXS_deffile("Thread::Channel::dequeue", XS_Thread__Channel_dequeue);
        newXS_deffile("Thread::Channel::dequeue_nb", XS_Thread__Channel_dequeue_nb);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

